=== debian/changelog ===
freerdp3 (3.6.3+dfsg1-2) unstable; urgency=medium

  * Revert "Add Build-Depends: libmp3lame-dev for MP3 audio codec support":
    the option is disabled by default and the feature is not used bu modern
    operating systems

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 09 Jul 2024 07:37:31 -0400

freerdp3 (3.6.3+dfsg1-1) unstable; urgency=medium

  [ Jeremy Bícha ]
  * Team upload
  * New upstream release
  * debian/*.symbols: Add new symbols
  * Add Build-Depends: libmp3lame-dev for MP3 audio codec support

  [ Michael Tokarev ]
  * d/rules: disable stack unwind (WINPR_HAVE_UNWIND_H=OFF) on armel and armhf

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 08 Jul 2024 18:37:15 +0300

freerdp3 (3.5.1+dfsg1-5) unstable; urgency=medium

  * Add patch to skip a test that fails on 32-bit arm (Closes: #1071949)

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 28 May 2024 12:40:03 -0400

freerdp3 (3.5.1+dfsg1-4) unstable; urgency=medium

  * Enable build time tests (LP: #2058401)

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 21 May 2024 11:56:19 -0400

freerdp3 (3.5.1+dfsg1-3) unstable; urgency=high

  [ Bernhard Miklautz ]
  * Performance improvements
    - Set -DNDEBUG (automatically set for Release but not for RelWithDebInfo)
    - Set -DWITH_VERBOSE_WINPR_ASSERT=OFF

  [ Nathan Pratta Teodosio ]
  * Add autopkgtest

  [ Jeremy Bícha ]
  * debian/*.symbols: Add new symbols
  * Release to unstable

 -- Jeremy Bícha <jbicha@ubuntu.com>  Wed, 01 May 2024 16:32:21 -0400

freerdp3 (3.5.1+dfsg1-2) experimental; urgency=medium

  * Enable proxy support
  * Enable the SDL client

 -- Bernhard Miklautz <bernhard.miklautz@shacknet.at>  Mon, 29 Apr 2024 15:07:11 -0400

freerdp3 (3.5.1+dfsg1-1) unstable; urgency=high

  [ Jeremy Bícha ]
  * New upstream release (Closes: #1069752)
    - CVE-2024-32658 [Low] ExtractRunLengthRegular* out of bound read
    - CVE-2024-32659 [Low] freerdp_image_copy out of bound read
    - CVE-2024-32660 [Low] zgfx_decompress out of memory
    - CVE-2024-32661 [Low] rdp_write_logon_info_v1 NULL access
    - CVE-2024-32662 [Low] rdp_redirection_read_base64_wchar out of bound read
  * Fix typo in enabling smartcard emulation
  * Update symbols files
  * Set symbols check level to 4

  [ Bernhard Miklautz ]
  * Update symbol files
  * debian/[control|rules]: enable WEBP, JPEG and PNG support for clipboard
  * debian/copyright[.in]: update copyright files
  * debian/control: update pkg-config binary package name

 -- Jeremy Bícha <jbicha@ubuntu.com>  Mon, 29 Apr 2024 14:50:09 -0400

freerdp3 (3.5.0+dfsg1-1) unstable; urgency=medium

  * Team upload
  * New upstream release (LP: #2061907)
    - CVE-2024-32039 [Moderate] Integer overflow & OutOfBound Write in
      clear_decompress_residual_data
    - CVE-2024-32040 [Low] integer underflow in nsc_rle_decode
    - CVE-2024-32041 [Low] OutOfBound Read in zgfx_decompress_segment
    - CVE-2024-32458 [Low] OutOfBound Read in planar_skip_plane_rle
    - CVE-2024-32459 [Low] OutOfBound Read in ncrush_decompress
    - CVE-2024-32460 [Low] OutOfBound Read in interleaved_decompress
  * Add freerdp3-dev Depends: libcjson-dev, libfuse3-dev
  * Release to unstable

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 15 Mar 2024 06:36:44 -0400
